#!/usr/bin/perl -T

# This script will simply return the UID of a NetID.
# This script first checks to make sure the NetID is valid.
# Then this script will attempt to first get the UID of the NetID,
# and if it's unable to do that, then it will generate (and reserve)
# the UID for the NetID.
#
# NOTE: If you are using UID_SYNC/UID_HOST, then it will use the UID
# master host to get/generate(reserve) the UID for the NetID.


require "/usr/local/accounts/lib/RatsLib.pm";
require "/usr/local/accounts/lib/RatsClientLib.pm";
require "/usr/local/accounts/etc/rats_internal.conf";

$do = \&RatsClientLib::send_remote_command;

my $num_args = $#ARGV + 1;
if ($num_args < 1) {
    print "Not enough arguments\n";
    exit;
}
my $username = $ARGV[0];

my ($result,$code,@data);
$result = &$do('GETIRFL_U',$username,$CONFIG::RATS_MASTER,$CONFIG::SERVER_PORT);
($code,@data) = split (":", $result);
if ($code != $CONFIG::API{'RETIRFL_U'}) {
    print "ERROR: $username: @data\n";
    exit;
}
else {
    my $handler_sub = $CONFIG::COMMAND_HOOKS{'GENUID'};
    my $uid = &$handler_sub($username);

    if ($uid == $CONFIG::BOGUS_UID) {
        print "ERROR: $username: Couldn't get UID\n";
    }
    else {
        print "$uid\n";
    }
}
